| Disk ARchive 2.5.10 Full featured and portable backup and archiving tool

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
libdar::tronc Class Reference
Private

makes a segment of a generic_file appear like a real generic_file More...

`#include <tronc.hpp>`

Inherits libdar::generic_file.

Inherited by libdar::trontextual.

## Public Member Functions
| tronc (generic_file *f, const infinint &offset, const infinint &size, bool own_f=false)
| constructor More...
| tronc (generic_file *f, const infinint &offset, const infinint &size, gf_mode mode, bool own_f=false)
| tronc (generic_file *f, const infinint &offset, bool own_f=false)
| tronc (generic_file *f, const infinint &offset, gf_mode mode, bool own_f=false)
| ~tronc ()
| destructor
void | modify (const infinint &new_offset, const infinint &new_size)
| modify the tronc object to zoom on another (size limited) portion of the underlying object
void | modify (const infinint &new_offset)
| modify the tronc object to zoom on another (size unlimited) portion of the underlying object
void | modify ()
| modify the tronc object to become transparent and allow unrestricted access to the underlyuing object
bool | skippable (skippability direction, const infinint &amount)
| inherited from generic_file
bool | skip (const infinint &pos)
| inherited from generic_file
bool | skip_to_eof ()
| inherited from generic_file
bool | skip_relative (S_I x)
| inherited from generic_file
infinint | get_position () const
| inherited from generic_file
void | check_underlying_position_while_reading_or_writing (bool mode)
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
virtual | ~generic_file () throw (Ebug)
| virtual destructor, this let inherited destructor to be called even from a generic_file pointer to an inherited class
void | terminate () const
| destructor-like call, except that it is allowed to throw exceptions
const generic_file & | operator= (const generic_file &ref)
| assignment operator
gf_mode | get_mode () const
| retreive the openning mode for this object
virtual void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
U_I | read (char *a, U_I size)
| read data from the generic_file More...
void | write (const char *a, U_I size)
| write data to the generic_file More...
void | write (const std::string &arg)
| write a string to the generic_file More...
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | copy_to (generic_file &ref)
| copy all data from current position to the object in argument
virtual void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value)
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data More...
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument More...
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data More...
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset More...
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::on_pool
void * | operator new (size_t n_byte)
void * | operator new (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new[] (size_t n_byte)
void * | operator new[] (size_t n_byte, const std::nothrow_t &nothrow_value)
void * | operator new (size_t n_byte, memory_pool *p)
void * | operator new[] (size_t n_byte, memory_pool *p)
void | operator delete (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated object
void | operator delete[] (void *ptr, memory_pool *p)
| this operator is called by the compiler if an exception is throw from the constructor of the allocated objects
void | operator delete (void *ptr)
| this is the usual delete operator, modified to handle allocated objects allocated on a memory pool or not
void | operator delete[] (void *ptr)
| this is the usual delete[] operator, modified to handle allocated objects allocated on a memory pool or not

## Protected Member Functions
void | inherited_read_ahead (const infinint &amount)
| inherited from generic_file
U_I | inherited_read (char *a, U_I size)
| inherited from generic_file
void | inherited_write (const char *a, U_I size)
| inherited from generic_file
void | inherited_sync_write ()
| write down any pending data More...
void | inherited_flush_read ()
void | inherited_terminate ()
| destructor-like call, except that it is allowed to throw exceptions More...
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const
Protected Member Functions inherited from libdar::on_pool
memory_pool * | get_pool () const
template<class T >
void | meta_new (T *&ptr, size_t num)
template<class T >
void | meta_delete (T *ptr)

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward, skip_forward }

## Detailed Description

makes a segment of a generic_file appear like a real generic_file

Definition at line 43 of file tronc.hpp.

## Constructor & Destructor Documentation

libdar::tronc::tronc | ( | generic_file * | f,
|  | const infinint & | offset,
|  | const infinint & | size,
|  | bool | own_f = `false`
| ) |  |

constructor

Parameters

  f | is the file to take the segment from
  offset | is the position of the beginning of the segment
  size | is the size of the segment
  own_f | is true if this object has to owns and may destroy the 'f' object at tronc's destruction time

libdar::tronc::tronc | ( | generic_file * | f,
|  | const infinint & | offset,
|  | bool | own_f = `false`
| ) |  |

other constructor, the end of the segment is the end of the underlying generic_file only data before offset is inaccessible

## Member Function Documentation

void libdar::tronc::check_underlying_position_while_reading_or_writing | ( | bool | mode | ) |
| inline

when a tronc is used over a compressor, it becomes necessary to disable position check

Note
  by default, before each read or write, the tronc object check that the underlying object is at adhoc position in regard to where the cursor is currently in the tronc. Disabling that check let ignore possible position mismatch (which are normal when a compressor is found below) while reading or writing but keep seeking the underlying object to the requested position upon any call to tronc::skip_* familly methods.

Definition at line 92 of file tronc.hpp.

void libdar::tronc::inherited_flush_read | ( |  | ) |
| inline protected virtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

Definition at line 103 of file tronc.hpp.

void libdar::tronc::inherited_sync_write | ( |  | ) |
| inline protected virtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

Definition at line 102 of file tronc.hpp.

References libdar::generic_file::sync_write().

void libdar::tronc::inherited_terminate | ( |  | ) |
| inline protected virtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

Definition at line 104 of file tronc.hpp.

References libdar::generic_file::terminate().

The documentation for this class was generated from the following file:

- tronc.hpp